########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_actgrp.4gs/screen1.trg  1.4  Delta: 2/20/91
########################################################################

defaults

input 1
    static_define
        dup_stmt char(128), # prepared variable used by check_dup function
        dup_prep char(1),   # flag: has check_dup function been prepped?
        ;

    after_change_in grp_key
        if check_dup() = true
        then
            call fg_err(2) # Duplicate Account Group
            let nxt_fld = "grp_key"
            return
        end if
        ;

    after_input
        if mustfill(p_xactgr.grp_key,"Account Group Key")
          then let nxt_fld = "grp_key" return end if
        if mustfill(p_xactgr.grp_desc,"Account Group Description")
          then let nxt_fld = "grp_desc" return end if
        ;

    at_eof
######################################################################
function check_dup()
# checks for duplicate value in a table (used with input statements)
# returns true if a duplicate value is found, otherwise false
######################################################################

define
    p_rowid smallint,
    p_count smallint

    if dup_prep is null
    then
        let dup_prep = "Y"
        let scratch = "select count(*) from stxactgr ",
                      "where grp_key = ? and rowid != ?"
        prepare dup_stmt from scratch
        declare dup_cur cursor for dup_stmt
    end if

    let p_rowid = get_scrlib("curs_rowid")

    open dup_cur using p_xactgr.grp_key, p_rowid
    fetch dup_cur into p_count
    close dup_cur

    if p_count > 0 then return true end if

    return false
   
end function
# check_dup()
        ;

input 2
    before_insert
        let scr_fld = null
        ;

    after_field acct_no
        if p_xactgd[p_cur].acct_no is null
          then let p_xactgd[p_cur].department = null end if
        ;

    after_field department
        call fgda_department()
        ;

    after_row
        if p_xactgd[p_cur].acct_no is null
          then let p_xactgd[p_cur].department = null end if
        call fgda_department()
        ;

    after_input
        # collapse the detail array upon leaving the detail section
        call collapse_array()
        ;

    at_eof
######################################################################
function fgda_department()
######################################################################
# logic to be executed after leaving the department field.
#
    if p_xactgd[p_cur].acct_no is not null
    then
        if p_xactgd[p_cur].department is null
          then let p_xactgd[p_cur].department = "000" end if
    end if

    if p_xactgd[p_cur].department is not null
    then 
        if mustfill(p_xactgd[p_cur].acct_no, "Account Number")
          then let nxt_fld = "acct_no" end if
    end if

end function 
# fgda_department

######################################################################
function collapse_array()
######################################################################
#  used to validate all detail rows before they are stored.

    define
          m       integer,   # Working number
          n       integer,   # Working number
          num_out integer    # Working number

    # initialize variables
    let m = 0
    let num_out = 0

    for n = 1 to rec1_cnt
      # criteria for validation
      if p_xactgd[n].acct_no is null or
         p_xactgd[n].department is null
      then
          let num_out = num_out + 1
          continue for
      end if
      let m = m + 1
      let p_xactgd[m].* = p_xactgd[m + num_out].*
      let q_xactgd[m].* = q_xactgd[m + num_out].*
    end for
    initialize p_xactgd[m + 1].* to null
    initialize q_xactgd[m + 1].* to null
    for n = (m + 2) to rec1_cnt
      let p_xactgd[n].* = p_xactgd[m + 1].*
      let q_xactgd[n].* = q_xactgd[m + 1].*
    end for
    let rec1_cnt = m

end function
# collapse_array
    ;
