########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/i_cashe.4gs/screen1.trg  1.2  Delta: 2/20/91
########################################################################

defaults
    define
        m_xcntrc record like stxcntrc.*,  # record like the company table
        ;

    after_init
        call xcontrol() returning m_xcntrc.*
        ;

input 1
    static_define
        dup_stmt  char(128),  # prepared variable used by check_dup function
        dup_prep  char(1),    # flag: has check_dup function has been prepped
        ;

    on_disk_delete
        call ring_clear()
        display " Deleting Check Register Transactions."
          at 1,1
        display " Please wait..."
          at 2,1
        delete from stxckrgd where
          stxckrgd.acct_no = p_xckrgr.acct_no and
          stxckrgd.department = p_xckrgr.department
        ;

    after_change_in acct_no
        if p_xckrgr.acct_no < m_xcntrc.curr_asset or
           p_xckrgr.acct_no >= m_xcntrc.curr_liab
        then
            call fg_err(2) # Checking account must be within asset range
            let nxt_fld = "acct_no"
            return
        end if
        if check_dup() = true
        then
            call fg_err(4)  # Duplicate def. of checking account/department
            let nxt_fld = "acct_no"
        end if
        ;

    after_field department
        # default department code to "000" when no entry was made
        if p_xckrgr.department is null
          then let p_xckrgr.department = "000" end if
        ;

    after_change_in department
        if check_dup() = true
        then
            # this combination of account/department is a duplicate
            call fg_err(4)  # Duplicate def. of checking account/department
            let nxt_fld = "department"
        end if
        ;

    after_input
        if mustfill(p_xckrgr.acct_no,"Account Number")
          then let nxt_fld = "acct_no" end if
        if mustfill(p_xckrgr.department,"Department Code")
          then let nxt_fld = "department" end if
        ;

    at_eof
##################################################################
function ok_update()
# returning true or false based upon ok to update
##################################################################
# 
#
    call fg_err(5) # Cannot Update Definitions.
                   #   Use Delete to Remove Definition.
    return false
end function
# ok_update()

##################################################################
function ok_delete()
# returning true or false based upon ok to delete
##################################################################
# 
#
    define
        prompt_response char(1)

    open window delete_rec at 14,16 with 9 rows, 51 columns
        attribute (border, blue, prompt line last)
    display "                  W A R N I N G !                  " at 1,1
        attribute (reverse)
    display "===================================================" at 2,1
    display " Deletion of this record will also delete all      " at 3,1
    display " check register transaction records associated     " at 4,1
    display " with this account number and department.          " at 5,1
    display "===================================================" at 8,1

    let prompt_response = null
    while prompt_response matches "[^yYnN]" or
          prompt_response is null
        prompt " Continue? " for prompt_response
    end while
    if upshift(prompt_response) = "N"
    then
      close window delete_rec
      return false
    end if

    close window delete_rec
    return true

end function
# ok_delete()

#####################################################################
function check_dup()
# returns true if a duplicate value in table is found
#####################################################################

define
    p_rowid integer,
    p_count smallint

    if dup_prep is null
    then
        let dup_prep = "Y"
        let scratch = "select count(*) from stxckrgr ",
                      "where acct_no = ? and ",
                      "department = ? ",
                      "and rowid != ?"
        prepare dup_stmt from scratch
        declare dup_cur cursor for dup_stmt
    end if

    let p_rowid  = get_scrlib("curs_rowid")

    open dup_cur using p_xckrgr.acct_no, p_xckrgr.department, p_rowid
    fetch dup_cur into p_count
    close dup_cur

    if p_count > 0 then return true end if
    return false
   
end function
# function check_dup()
    ;
