########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/lib.4gs/ic_post.4gl  1.1  Delta: 1/4/91
########################################################################

globals "ic_glob.4gl"

########################################################################
function ic_post(post_or_check, orig_journal, doc_no,
                 post_no, post_date, doc_date, ref_code, doc_desc,
                 doc_type, ref_no, line_no, item_code, warehouse_code,
                 qty, cost, price)
# returns sets post_ic.status to "1" and post_ic.ic_installed to "N" and
# returns true.
########################################################################
# this function is a "stub" function that does nothing.  its purpose is
# to inform calling programs that the inventory control module is not
# installed.  this function resides in the basefiles library, and thus
# will only be linked into calling programs if inventory control module
# really isn't installed.
#
# if inventory control is installed after order entry or purchasing,
# the posting program(s) for those modules must be relinked to they
# will call the true ic_post function and not this stub.
#

    define
        # passed variables
        post_or_check char(5),
        orig_journal like stxtranr.orig_journal,
        doc_no like stxtranr.doc_no,
        post_no like stxtranr.post_no,
        post_date like stxtranr.post_date,
        doc_date like stxtranr.doc_date,
        ref_code like stxtranr.ref_code,
        doc_desc like stxtranr.doc_desc,
        doc_type char(2),
        ref_no   char(10),
        line_no  smallint,
        item_code char(20),
        warehouse_code char(3),
        qty decimal(10),
        cost decimal(12),
        price decimal(12)

    # Trap fatal errors
    whenever error call error_handler

    # set post_ic.status to "1".  this is the status code indicating
    # that ic is not installed.  set ic_installed to "N".  this ought
    # to be enough to do it.
    let post_ic.ic_installed = "N"
    let post_ic.status = 1
    return true

end function
# ic_post()

