########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_actgrp.4gs/report.4gl  1.4  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            line_no like stxactgd.line_no,
            co_name like stxcntrc.co_name,
            grp_key like stxactgr.grp_key,
            grp_desc like stxactgr.grp_desc,
            acct_no like stxactgd.acct_no,
            department like stxactgd.department,
            acct_desc like stxchrtr.acct_desc
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.grp_key, rpt.line_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Account Groups"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Account Groups";
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.grp_key
            need 5 lines
            print
                column  11, "Account Group Code: ",
                column  31, upshift(rpt.grp_key) clipped
            print
                column   4, "Account Group Description: ",
                column  31, upshift(rpt.grp_desc) clipped
            print
            print
                column  17, "Account No.",
                column  31, "Description"
            print
                column  17, "------------",
                column  31, "-------------------------------"

        on every row
            print
                column  17, rpt.acct_no using "######",
                column  24, "-",
                column  25, rpt.department,
                column  31, rpt.acct_desc

        after group of rpt.grp_key
            need 2 lines
            print
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()

