########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_actrng.4gs/report.4gl  1.5  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            curr_asset like stxcntrc.curr_asset,
            fixed_asset like stxcntrc.fixed_asset,
            curr_liab like stxcntrc.curr_liab,
            long_term_liab like stxcntrc.long_term_liab,
            capital like stxcntrc.capital,
            income like stxcntrc.income,
            cost_goods like stxcntrc.cost_goods,
            expense like stxcntrc.expense
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin      3
        bottom margin   3
        left margin     0
        right margin    80
        page length     66

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Account Number Ranges"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            let scratch = "Account Number Ranges"
            print
                column   1, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        on every row
            need 9 lines
            print
            print
                column  11, "First Current Asset Account: ",
                column  40, rpt.curr_asset using "<<<<<<<<<<"
            print
                column  13, "First Fixed Asset Account: ",
                column  40, rpt.fixed_asset using "<<<<<<<<<<"
            print
                column   7, "First Current Liability Account: ",
                column  40, rpt.curr_liab using "<<<<<<<<<<"
            print
                column   5, "First Long Term Liability Account: ",
                column  40, rpt.long_term_liab using "<<<<<<<<<<"
            print
                column   7, "First Equity or Capital Account: ",
                column  40, rpt.capital using "<<<<<<<<<<"
            print
                column   9, "First Income or Sales Account: ",
                column  40, rpt.income using "<<<<<<<<<<"
            print
                column  11, "First Cost of Goods Account: ",
                column  40, rpt.cost_goods using "<<<<<<<<<<"
            print
                column   7, "First Operation Expense Account: ",
                column  40, rpt.expense using "<<<<<<<<<<"

end report
# report1()

