########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_chtlst.4gs/midlevel.4gl  1.3  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    let ct.sel_join = "1=1"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "stxchrtr.acct_cat, stxchrtr.processing_seq, stxchrtr.acct_no, stxchrtr.subtotal_group"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stxchrtr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stxchrtr.acct_cat, ",
            "stxchrtr.acct_type, ",
            "stxchrtr.subtotal_group, ",
            "stxchrtr.acct_no, ",
            "stxchrtr.acct_desc, ",
            "stxchrtr.incr_with_crdt, ",
            "stxchrtr.processing_seq ",
        "from stxchrtr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.acct_cat = curs_next.acct_cat
    let curs.acct_type = curs_next.acct_type
    let curs.subtotal_group = curs_next.subtotal_group
    let curs.acct_no = curs_next.acct_no
    let curs.acct_desc = curs_next.acct_desc
    let curs.incr_with_crdt = curs_next.incr_with_crdt
    let curs.processing_seq = curs_next.processing_seq
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.acct_cat = curs_next.acct_cat
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("acct_cat")
        let no_break = false
    end if
    if no_break and curs.processing_seq = curs_next.processing_seq
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("processing_seq")
        let no_break = false
    end if
    if no_break and curs.acct_no = curs_next.acct_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("acct_no")
        let no_break = false
    end if
    if no_break and curs.subtotal_group = curs_next.subtotal_group
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("subtotal_group")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.acct_cat = curs_next.acct_cat
    then else
        call after_group("acct_cat")
        let no_break = false
    end if
    if no_break and curs.processing_seq = curs_next.processing_seq
    then else
        call after_group("processing_seq")
        let no_break = false
    end if
    if no_break and curs.acct_no = curs_next.acct_no
    then else
        call after_group("acct_no")
        let no_break = false
    end if
    if no_break and curs.subtotal_group = curs_next.subtotal_group
    then else
        call after_group("subtotal_group")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Ledger Account Listing"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
end function
# ml_defaults()

