########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_xinfor.4gs/lowlevel.4gl  1.6  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#####################################################################
function before_group(group_key)
#####################################################################
#
    define
        group_key   char(20)    # group identification

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = "src_type" then
        # insert "before group of src_type" code here
        let rpt.head2 = " Code     Description"
		case
			when curs.src_type = "S"
				let rpt.head1 = "Type: [S] - General Journal Sources"
			when curs.src_type = "D"
				let rpt.head1 = "Type: [D] - Department Codes"
			when curs.src_type = "W"
				let rpt.head1 = "Type: [W] - Warehouse Codes"
				let rpt.head2 = rpt.head2 clipped,
                    "               Shipping Lead Time    Dept"
			when curs.src_type = "P"
				let rpt.head1 = "Type: [P] - Product Class Codes"
			when curs.src_type = "L"
				let rpt.head1 = "Type: [L] - Salesperson Codes"
				let rpt.head2 = " Code     Name                             ",
                    "               Commission Code     "
			when curs.src_type = "T"
				let rpt.head1 = "Type: [T] - Sales Tax Codes"
				let rpt.head2 = rpt.head2 clipped,
                    "                         Rate                Account"
			when curs.src_type = "C"
				let rpt.head1 = "Type: [C] - Commission Codes"
				let rpt.head2 = rpt.head2 clipped,
				    "                         Rate             "
			when curs.src_type = "R"
				let rpt.head1 = "Type: [R] - Debit/Credit Reason Codes"
				let rpt.head2 = rpt.head2 clipped,
				    "                     Type"
			when curs.src_type = "N"
				let rpt.head1 = "Type: [N] - Purchase Order Debit/Credit Reason Codes"
				let rpt.head2 = rpt.head2 clipped,
				    "                     Type"
			when curs.src_type = "I"
				let rpt.head1 = "Type: [I] - Discount Definitions"
				let rpt.head2 = rpt.head2 clipped,
				    "                         Rate        Type"
			when curs.src_type = "B"
				let rpt.head1 = "Type: [B] - Buyer Codes"
				let rpt.head2 = " Code     Name                             "
			when curs.src_type = "M"
				let rpt.head1 = "Type: [M] - Method of Payment"
				let rpt.head2 = " Code     Description                      ",
                    "               Type"
        end case
        return
    end if

end function
# before_group()

#####################################################################
function on_every_row()
#####################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    let rpt.src_type = curs.src_type
#   let rpt.co_name = (MUST SUPPLY)
    let rpt.src_key = curs.src_key
    let rpt.src_desc = curs.src_desc
    if rpt.src_type = "W" or rpt.src_type = "R" or rpt.src_type = "N"
    then
        let rpt.src_num_desc = curs.src_num_desc using "##"
    else
        let rpt.src_num_desc = curs.src_num_desc using "##&.&&"
    end if
    let rpt.src_char_desc = curs.src_char_desc
    let rpt.src_acct_no = curs.src_acct_no
    return
end function
# on_every_row()

#####################################################################
function after_group(group_key)
#####################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "src_type" then
        # insert "after group of src_type" code here
		let rpt.tail1 = null
		let rpt.tail2 = null
		let rpt.tail3 = null
		let rpt.tail4 = null
		let rpt.tail5 = null
		let rpt.tail6 = null
		case
			when curs.src_type = "I"
      			let rpt.tail4 = "MARKUP - Adds rate to inventory",
                           	" cost to compute price."
            	let rpt.tail5 = "         Quantity discounts are ignored."
            	let rpt.tail6 = "DISCNT - Computes trade discount amount",
                            	" on price as entered or computed."
			when curs.src_type = "R"
            	let rpt.tail1 = "Reason Types                    Sales    ",
                                "  COG        Inventory  Scrappage    "
            	let rpt.tail2 = "-----------------------------   ---------",
                        	"  ---------  ---------  ---------"
            	let rpt.tail3 = "(1) Returned and scrapped       Decrease  ",
                        	" Decrease   No Change  Increase"
            	let rpt.tail4 = "(2) Returned and restocked      Decrease  ",
                        	" Decrease   Increase   No Change"
            	let rpt.tail5 = "(3) Overpriced, not returned    Decrease  ",
                        	" No Change  No Change  No Change"
            	let rpt.tail6 = "(4) Underpriced, not returned   Increase  ",
                        	" No Change  No Change  No Change"
			when curs.src_type = "N"
            	let rpt.tail1 = "Purchase Order Reason Types     Inventory QOH",
                                "         Inventory  Cash/AR  "
            	let rpt.tail2 = "-----------------------------   -------------",
                                "         ---------  --------- "
            	let rpt.tail3 = "(1) Returned                    Decrease     ",
                                "         Decrease   Increase"
            	let rpt.tail4 = "(2) Adjustment Overpriced       No Change    ",
                                "         Decrease   Increase "
            	let rpt.tail5 = "(3) Over Shipment               Increase     ",
                                "         Increase   Decrease"
            	let rpt.tail6 = "(4) Adjustment Underpriced      No Change    ",
                                "         Increase   Decrease"
    	end case
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()
