########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_xinfor.4gs/midlevel.4gl  1.5  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#####################################################################
function ml_join()
#####################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    let ct.sel_join = "1=1"
    return
end function
# ml_join()

#####################################################################
function ml_filter()
#####################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#####################################################################
function ml_order()
#####################################################################
#
    let ct.sel_order = "stxinfor.src_type"
    return
end function
# ml_order()

#####################################################################
function ml_getcount()
#####################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stxinfor ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#####################################################################
function ml_define_cur()
#####################################################################
#
    let ct.sel_stmt =
        "select ",
            "stxinfor.src_type, ",
            "stxinfor.src_key, ",
            "stxinfor.src_desc, ",
            "stxinfor.src_num_desc, ",
            "stxinfor.src_char_desc, ",
            "stxinfor.src_acct_no ",
        "from stxinfor ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#####################################################################
function ml_fetch()
#####################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#####################################################################
function ml_curs_null()
#####################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#####################################################################
function ml_next_null()
#####################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#####################################################################
function ml_curs_prep()
#####################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.src_type = curs_next.src_type
    let curs.src_key = curs_next.src_key
    let curs.src_desc = curs_next.src_desc
    let curs.src_num_desc = curs_next.src_num_desc
    let curs.src_char_desc = curs_next.src_char_desc
    let curs.src_acct_no = curs_next.src_acct_no
end function
# ml_curs_prep()

#####################################################################
function ml_before_break()
#####################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.src_type = curs_next.src_type
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("src_type")
        let no_break = false
    end if
end function
# ml_before_break()

#####################################################################
function ml_after_break()
#####################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.src_type = curs_next.src_type
    then else
        call after_group("src_type")
        let no_break = false
    end if
end function
# ml_after_break()

#####################################################################
function ml_output()
#####################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#####################################################################
function ml_defaults()
#####################################################################
#  this function sets the ct.* record values
#
    define
        n smallint,
        src_type char(60),
        src_char char(1)

    for n = 1 to num_args() - 1
        if arg_val(n) = "-t"
        then
            let src_type = arg_val(n+1)
            let src_char = upshift(src_type[1])
        end if
    end for

    case src_char
        when "S"
            let ct.sel_filter = "stxinfor.src_type = \"S\""
        when "D"
            let ct.sel_filter = "stxinfor.src_type = \"D\""
        when "W"
            let ct.sel_filter = "stxinfor.src_type = \"W\""
        when "P"
            let ct.sel_filter = "stxinfor.src_type = \"P\""
        when "L"
            let ct.sel_filter = "stxinfor.src_type = \"L\""
        when "T"
            let ct.sel_filter = "stxinfor.src_type = \"T\""
        when "C"
            let ct.sel_filter = "stxinfor.src_type = \"C\""
        when "R"
            let ct.sel_filter = "stxinfor.src_type = \"R\""
        when "N"
            let ct.sel_filter = "stxinfor.src_type = \"N\""
        when "I"
            let ct.sel_filter = "stxinfor.src_type = \"I\""
        when "B"
            let ct.sel_filter = "stxinfor.src_type = \"B\""
        when "M"
            let ct.sel_filter = "stxinfor.src_type = \"M\""
        otherwise
            let ct.sel_filter = "1=1"
    end case

    let ct.prcname = "Reference Information List"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
end function
# ml_defaults()

