########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../all.4gm/o_xinfor.4gs/report.4gl  1.4  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            src_type like stxinfor.src_type,
            co_name char(30),
            head1 char(79),
            head2 char(79),
            src_key like stxinfor.src_key,
            src_desc like stxinfor.src_desc,
            src_num_desc char(10),
            src_char_desc like stxinfor.src_char_desc,
            src_acct_no like stxinfor.src_acct_no,
            tail1 char(79),
            tail2 char(79),
            tail3 char(79),
            tail4 char(79),
            tail5 char(79),
            tail6 char(79)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80
        page length     66

    order external by rpt.src_type

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Reference Information List"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   1, rpt.head1
            print
            print
                column   1, rpt.head2
            print
                column   1, "========================================",
                column  41, "======================================="

        page trailer
            if
                rpt.tail1 is not null
            then
                print
                    column   1, rpt.tail1
                        else
                                print
            end if
            if
                rpt.tail2 is not null
            then
                print
                    column   1, rpt.tail2
                        else
                                print
            end if
            if
                rpt.tail3 is not null
            then
                print
                    column   1, rpt.tail3
                        else
                                print
            end if
            if
                rpt.tail4 is not null
            then
                print
                    column   1, rpt.tail4
                        else
                                print
            end if
            if
                rpt.tail5 is not null
            then
                print
                    column   1, rpt.tail5
                        else
                                print
            end if
            if
                rpt.tail6 is not null
            then
                print
                    column   1, rpt.tail6
                        else
                                print
            end if
            print
                column   1, "========================================",
                column  41, "======================================="
            print
                column   1, "Reference Information List";
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.src_type
            skip to top of page

        on every row
            print
                column   2, rpt.src_key,
                column  11, rpt.src_desc,
                column  44, rpt.src_num_desc,
                column  58, rpt.src_char_desc,
                column  70, rpt.src_acct_no using "######"


end report
# report1()

