#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../gl.4gm/p_delete.4gs/lowlevel.4gl  1.10  Delta: 3/19/91
#####################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    define
        m_gactvv record
            orig_journal like stxtranr.orig_journal,
            doc_no like stxtranr.doc_no,
            post_no like stxtranr.post_no,
            post_date like stxtranr.post_date,
            doc_date like stxtranr.doc_date,
            ref_code like stxtranr.ref_code,
            acct_period like stgtranr.acct_period,
            acct_year like stgtranr.acct_year,
            acct_no like stgactvd.acct_no,
            department like stgactvd.department,
            amount like stgactvd.amount,
            debit_credit like stgactvd.debit_credit
        end record

    let rpt.orig_journal = curs.orig_journal
    let rpt.doc_no = curs.doc_no
    let rpt.acct_period = curs.acct_period
    let rpt.acct_year = curs.acct_year
    let rpt.status = curs.status
    declare trx_cursor cursor for select
        stxtranr.orig_journal,
        stxtranr.doc_no,
        stxtranr.post_no,
        stxtranr.post_date,
        stxtranr.doc_date,
        stxtranr.ref_code,
        stgtranr.acct_period,
        stgtranr.acct_year,
        stgactvd.acct_no,
        stgactvd.department,
        stgactvd.amount,
        stgactvd.debit_credit
     from stgtranr , stxtranr, stgactvd
     where stgtranr.doc_no = stxtranr.doc_no and
           stgtranr.orig_journal = stxtranr.orig_journal and
           stgtranr.doc_no = stgactvd.doc_no and
           stgtranr.orig_journal = stgactvd.orig_journal and
           stxtranr.orig_journal = rpt.orig_journal and
           stxtranr.doc_no = rpt.doc_no

    foreach trx_cursor into m_gactvv.*
        let rpt.data = m_gactvv.orig_journal, " ",
                       m_gactvv.doc_no using "######", " ",
                       m_gactvv.post_no, " ",
                       m_gactvv.doc_date, " ",
                       m_gactvv.ref_code, " ",
                       m_gactvv.acct_period, " ",
                       m_gactvv.acct_year, " ",
                       m_gactvv.acct_no using "####", " ",
                       m_gactvv.department, " ",
                       m_gactvv.amount
        if m_gactvv.debit_credit = "D"
          then let rpt.data = rpt.data clipped, "  DB"
          else let rpt.data = rpt.data clipped, "  CR"
        end if
        call ml_output()
        # Send the line to the summary tables
        call gl_sumput(m_gactvv.doc_no, m_gactvv.acct_period,
                       m_gactvv.acct_year, m_gactvv.acct_no,
                       m_gactvv.department, m_gactvv.amount,
                       m_gactvv.debit_credit)
    end foreach
    let rpt.data = null

    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "doc_no" then
        # insert "after group of doc_no" code here
        begin work
        delete from stgactvd where stgactvd.orig_journal = rpt.orig_journal
            and stgactvd.doc_no = rpt.doc_no
        delete from stgtranr where stgtranr.orig_journal = rpt.orig_journal
            and stgtranr.doc_no = rpt.doc_no
        commit work
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        begin work
        call del_trx(p_arc_date)
        commit work
        return
    end if

end function
# after_group()

