########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../gl.4gm/p_delete.4gs/midlevel.4gl  1.8  Delta: 1/16/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote char(1)

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""
        let ct.sel_join = "stxtranr.orig_journal = stgtranr.orig_journal and ",
                          "stxtranr.doc_no = stgtranr.doc_no"

    if table_exist("stgcntrc")
    then
        let ct.sel_join = ct.sel_join clipped, 
            " and stgtranr.status = ", quote, "P", quote
    end if

    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "orig_journal, doc_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select stxtranr.rowid h1_row, ",
        "stgtranr.rowid h2_row, ",
        "stxtranr.orig_journal, ",
        "stxtranr.doc_no ",
        "from stxtranr, stgtranr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ") into temp curs_temp"
    if is_4_0()
    then
        let ct.sel_stmt = ct.sel_stmt clipped, " with no log"
    end if
    prepare get_count from ct.sel_stmt
    execute get_count
    let ct.num_rows = sqlca.sqlerrd[3]
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    if ct.sel_order is not null
    then
        let ct.sel_stmt =
            "create cluster index i1curs on curs_temp (",
            ct.sel_order clipped, ")"
        prepare get_curs from ct.sel_stmt
        execute get_curs
    end if
    select min(rowid) into p_cur_row from curs_temp
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    while true
        select h1_row, h2_row
          into header1_row, header2_row
          from curs_temp where rowid = p_cur_row
        if sqlca.sqlcode = 0 then exit while end if
        select min(rowid) into p_cur_row from curs_temp
          where rowid >= p_cur_row
    end while
    let p_cur_row = p_cur_row + 1
    select
        stxtranr.orig_journal,
        stxtranr.doc_no,
        stgtranr.acct_period,
        stgtranr.acct_year,
        stgtranr.status
    into
        curs_next.orig_journal,
        curs_next.doc_no,
        curs_next.acct_period,
        curs_next.acct_year,
        curs_next.status
    from stxtranr, stgtranr
        where stxtranr.rowid = header1_row
          and stgtranr.rowid = header2_row
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.orig_journal = curs_next.orig_journal
    let curs.doc_no = curs_next.doc_no
    let curs.acct_period = curs_next.acct_period
    let curs.acct_year = curs_next.acct_year
    let curs.status = curs_next.status
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint,   # working number
        arg_flag char(1),   # archive type D=date, P=period, Z=prompt user
        arc_date date,
        arc_period char(2),
        arc_year char(4),
        period_no smallint,
        quote char(1)

    let arg_flag = "Z"

    for n = 1 to num_args()
        if arg_val(n) = "-date"
        then
            let arc_date = arg_val(n+1)
            let arg_flag = "D"
            exit for
        end if
        if arg_val(n) = "-period"
        then
            let arc_period = arg_val(n+1)
            let arg_flag = "P"
            exit for
        end if
    end for
    if arg_flag = "Z"
    then
        open window selwin at 6, 6 with 14 rows, 70 columns
                attribute (border, blue)
        call menu_line()
        while arg_flag != "P" and arg_flag != "D"
            prompt " Archive by (P)eriod or by (D)ate? " for char arg_flag 
            if arg_flag is null then let arg_flag = "Z" end if
            if int_flag != 0
            then
                exit program(1)
            end if 
            let arg_flag = upshift(arg_flag)
            if arg_flag != "P" and arg_flag !="D"
            then
                call fg_err(1) #Enter a "P" for Month or a "D" for Date
            end if
        end while
        if upshift(arg_flag) = "P" 
        then
            let arg_flag = "Z"
            while arg_flag != "P"
                prompt
          " Enter the number of periods before current one to archive: "
                    for arc_period
                if int_flag != 0
                then
                    exit program(1)
                end if 
                let status = 0
                whenever error continue
                let period_no = arc_period
                whenever error call error_handler
                if status = 0
                then
                    let arg_flag = "P"
                else
                    let status = 0
                    call fg_err(2) #Enter a valid number
                end if
            end while
        else 
            let arg_flag = "Z"
            while arg_flag != "D"
                prompt " Enter the Archive Date: " 
                    for arc_date
                if int_flag != 0
                then
                    exit program(1)
                end if 
                if status = 0
                then
                    let arg_flag = "D"
                else
                    let status = 0
                    call fg_err(3) #Enter a valid date
                end if
             end while
        end if
        close window selwin
    end if
    let quote = "\""
    if arg_flag = "P"
    then
        call prev_period(period_no) returning arc_period, arc_year
        let ct.sel_filter = "stgtranr.acct_year <= ", quote, arc_year, quote,
             " and stgtranr.acct_period <= ", quote, arc_period, quote
        let rpt.heading = "Delete G/L Activity before " ,
                          arc_period, "-", arc_year
        select end_date into p_arc_date 
          from stxperdr 
          where stxperdr.period = arc_period and
                stxperdr.period_year = arc_year
    else
        let ct.sel_filter = "stxtranr.doc_date <= ", quote, arc_date, quote
        let rpt.heading = "Delete G/L Activity on or before ", arc_date
        let p_arc_date = arc_date
    end if 
    let ct.prcname = "Delete Old G/L Activity"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.quiet = "1"
    let ct.allow_int = "N"
    let ct.prc_only = "N"
    let ct.destin = "report.out"
    let rpt.co_name = al_compn()
end function
# ml_defaults()
