########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../gl.4gm/p_delete.4gs/report.4gl  1.7  Delta: 2/10/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            orig_journal like stxtranr.orig_journal,
            doc_no like stxtranr.doc_no,
            acct_period like stgtranr.acct_period,
            acct_year like stgtranr.acct_year,
            status like stgtranr.status,
            heading char(60),
            co_name like stxcntrc.co_name,
            data char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.doc_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "OJ",
                column   4, "Doc No",
                column  14, "Post No",
                column  25, "Date",
                column  32, "Ref",
                column  39, "Per",
                column  43, "Yr",
                column  47, "Acct",
                column  52, "Dept",
                column  60, "Amount",
                column  67, "DB/CR"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
                let scratch = rpt.heading
            print
                column   1, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        on every row
            if rpt.data is not null
            then
                print
                    column   1, rpt.data
            end if

        on last row
            # Additional lines for the g/l summary report
            skip to top of page
            call gl_sumrpt()
            print file "sumrpt.out"
           
end report
# report1()

